import { RunOptions } from './types/common';
import { Output } from './Output/index';
export declare class Config {
    /**
     * Local settings
     */
    out: Output;
    debug: boolean;
    windows: boolean;
    bin: string;
    mock: boolean;
    argv: string[];
    commandsDir: string;
    defaultCommand: string;
    userPlugins: boolean;
    version: string;
    name: string;
    pjson: any;
    sharedClusters: string[];
    /**
     * Paths
     */
    cwd: string;
    home: string;
    root: string;
    definitionDir: string;
    definitionPath: string | null;
    localRCPath: string;
    globalRCPath: string;
    warnings: string[];
    /**
     * Urls
     */
    authUIEndpoint: string;
    backendAddr: string;
    systemAPIEndpoint: string;
    authEndpoint: string;
    docsEndpoint: string;
    statusEndpoint: string;
    /**
     * consumer endpoints
     */
    simpleAPIEndpoint: string;
    relayAPIEndpoint: string;
    fileAPIEndpoint: string;
    subscriptionsEndpoint: string;
    __cache: {};
    constructor(options?: RunOptions);
    setLocal(host?: string): void;
    setOutput(out: Output): void;
    readonly arch: string;
    readonly platform: string;
    readonly userAgent: string;
    readonly dirname: any;
    readonly cacheDir: string;
    private readPackageJson(options);
    private setRCPaths();
    private warn(msg);
    private setDefinitionPaths();
    private getCwd();
    private getHome();
}
