"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var cuid = require("cuid");
var path = require("path");
var os = require("os");
var fs = require("fs-extra");
var Config_1 = require("./Config");
var mockDotFile = {
    "token": "test-token"
};
describe('config', function () {
    test('should init paths correct in subfolder', function () { return __awaiter(_this, void 0, void 0, function () {
        var home, definitionDir, cwd, config;
        return __generator(this, function (_a) {
            home = path.join(os.tmpdir(), "" + cuid());
            definitionDir = path.join(os.tmpdir(), "" + cuid());
            cwd = path.join(definitionDir, 'src');
            fs.mkdirpSync(definitionDir);
            fs.mkdirpSync(home);
            fs.copySync(path.join(__dirname, '../test/test-project'), definitionDir);
            config = new Config_1.Config({ mock: true, home: home, cwd: cwd });
            expect(config.definitionDir).toBe(definitionDir);
            expect(config.definitionPath).toBe(path.join(definitionDir, 'graphcool.yml'));
            return [2 /*return*/];
        });
    }); });
    test('should allow .graphcool file in current folder', function () { return __awaiter(_this, void 0, void 0, function () {
        var home, definitionDir, cwd, dotGraphcoolPath, config;
        return __generator(this, function (_a) {
            home = path.join(os.tmpdir(), "" + cuid());
            definitionDir = path.join(home, 'definition');
            cwd = path.join(definitionDir, 'src');
            fs.mkdirpSync(definitionDir);
            fs.mkdirpSync(home);
            fs.copySync(path.join(__dirname, '../test/test-project'), definitionDir);
            dotGraphcoolPath = path.join(definitionDir, '.graphcool');
            fs.writeFileSync(dotGraphcoolPath, JSON.stringify(mockDotFile));
            config = new Config_1.Config({ mock: true, home: home, cwd: cwd });
            config.loadDotGraphcool();
            expect(config.dotGraphcoolFilePath).toBe(dotGraphcoolPath);
            expect(config.token).toBe(mockDotFile.token);
            return [2 /*return*/];
        });
    }); });
});
//# sourceMappingURL=Config.test.js.map